/*
 * (c) 2008-2009 Technische Universität Dresden
 * This file is part of TUD:OS and distributed under the terms of the
 * GNU General Public License 2.
 * Please see the COPYING-GPL-2 file for details.
 *
 * As a special exception, you may use this file as part of a free software
 * library without restriction.  Specifically, if other files instantiate
 * templates or use macros or inline functions from this file, or you compile
 * this file and link it with other files to produce an executable, this
 * file does not by itself cause the resulting executable to be covered by
 * the GNU General Public License.  This exception does not however
 * invalidate any other reasons why the executable file might be covered by
 * the GNU General Public License.
 */

#include <l4/re/c/fb.h>

#include <l4/re/fb>
#include <l4/re/dataspace>
#include <l4/sys/err.h>

L4_CV int
l4re_fb_info(l4re_fb_t fb, l4re_fb_info_t *info) L4_NOTHROW
{
  L4::Cap<L4Re::Framebuffer> f(fb);
  L4Re::Framebuffer::Info *i = (L4Re::Framebuffer::Info *)info;
  return f->info(i);
}

L4_CV int
l4re_fb_mem(l4re_fb_t fb, l4re_ds_t ds) L4_NOTHROW
{
  L4::Cap<L4Re::Framebuffer> f(fb);
  L4::Cap<L4Re::Dataspace> d(ds);
  return f->mem(d);
}

L4_CV int
l4re_fb_refresh(l4re_fb_t fb, int x, int y, int w, int h) L4_NOTHROW
{
  L4::Cap<L4Re::Framebuffer> f(fb);
  return f->refresh(x, y, w, h);
}
