/*
 * (c) 2008-2009 Technische Universität Dresden
 * This file is part of TUD:OS and distributed under the terms of the
 * GNU Lesser General Public License 2.1.
 * Please see the COPYING-LGPL-2.1 file for details.
 */
#include <l4/libloader/name_space_cfg>

namespace Ldr {

namespace Names { using namespace L4Re::Util::Names; }

void
Names_parser::assignment(Names::Entry *lval)
{
  Val rhs = capability_rvalue();

  if (rhs.is_local_entry())
    {
      lval->obj(Names::Obj(rhs.flags()));
      if (!lval->link(rhs.entry()))
	_ns->make_incomplete(lval);
    }
  else
    lval->obj(Names::Obj(rhs.flags(), rhs.cap()));

  return;
}

void
Names_parser::cap_rval(void *entry)
{
  Names::Entry *e = (Names::Entry*)entry;
  shift();
  unsigned flags = 0;
  if (cur().type() == Ldr::Token::Comma)
    {
      flags = parse_flags();
      shift();
    }
  if (cur().type() == Ldr::Token::Semicolon)
    {
      unsigned f = Names::Obj::F_replacable | flags;
      e->obj(Names::Obj(f));
      return;
    }

  if (cur().type() == Ldr::Token::Assign)
    {
      shift();
      assignment(e);
      return;
    }

  throw Parse_exception(_scan, cur(), "syntax error, unexpected token:");
}

}
