#include <cstdio>
#include <l4/re/util/object_registry>
#include <l4/cxx/ipc_server>
#include <l4/cxx/ipc_stream>

static L4Re::Util::Registry_server<> the_server;

/*
 * Class to dispatch calls to the VCON protocol.
 *
 * The main interesting opcode here is L4_VCON_WRTIE_OP. The message buffer
 * format for this operation is:
 *
 * tag.label() == L4_PROTO_LOG
 * UTCB.mr[0] == L4_VCON_WRITE
 * UTCB.mr[1] == string size
 * UTCB.mr[2:...] == characters to print
 */
class Logging_server : public L4::Server_object
{
	public:
		Logging_server()
		{ }

		int dispatch(l4_umword_t, L4::Ipc_iostream& ios)
		{
			/*
			 * 1. Check label for protocol validity
			 * (L4_PROTO_LOG)
			 */


			/*
			 * 2. Get opcode from IPC stream
			 */


			/*
			 * 3. Handle opcode(s)
			 *
			 * L4_VCON_WRITE_OP
			 *
			 * Not necessary in this scenario:
			 * L4_VCON_SET_ATTR_OP
			 * L4_VCON_GET_ATTR_OP
			 */

			return -L4_ENOSYS;
		}
};


int main(int argc, char **argv)
{
	(void)argc;
	(void)argv;

	static Logging_server srv;

	L4::Cap<void> c = the_server.registry()->register_obj(&srv, "logger");

	if (!c.is_valid()) {
		printf("Object registration failed.\n");
		return -1;
	}

	printf("Logger up and running.\n");

	the_server.loop();

	return 0;
}
