/*
 * (c) 2008-2009 Technische Universität Dresden
 * This file is part of TUD:OS and distributed under the terms of the
 * GNU General Public License 2.
 * Please see the COPYING-GPL-2 file for details.
 */
#include "loader_script.h"
#include "boot_fs.h"
#include "dataspace_cont.h"


int
Moe::Loader_script::open_file(char const *file)
{
  Moe::Dataspace *f = Boot_fs::open_file(file);
  if (!f)
    return -L4_ENOENT;

  Moe::Dataspace_cont *fc = dynamic_cast<Moe::Dataspace_cont*>(f);

  if (!fc)
    {
      _err.printf("script parser supports only contiguous data spaces\n");
      return -L4_ENOENT;
    }

  init(f->address(0).adr<char const*>(), fc->size(), file);
  return 0;
}

