/*
 * Copyright (C) 2000-2006 Erik Andersen <andersen@uclibc.org>
 *
 * Licensed under the LGPL v2.1, see the file COPYING.LIB in this tarball.
 */

/* L4: Just shortcut getdents* for now... */

#include <features.h>
#include <errno.h>

#if defined __UCLIBC_HAS_LFS__ && defined __NR_getdents64

ssize_t __getdents64 (int fd, char *buf, size_t nbytes) attribute_hidden;
ssize_t __getdents64 (int fd, char *buf, size_t nbytes)
{
        (void)fd; (void)buf; (void)nbytes;
        errno = -EBADF;
	return -1;
}

#if __WORDSIZE == 64
/* since getdents doesnt give us d_type but getdents64 does, try and
 * use getdents64 as much as possible */
attribute_hidden strong_alias(__getdents64,__getdents)
#endif

#endif
